unit HostAppU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, upfManager, upfIntf, StdCtrls, ExtCtrls, Menus, Buttons;

type
  TForm1 = class(TForm)
    upfPluginManager1: TupfPluginManager;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Plugin1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Panel1: TPanel;
    clbPlugins: TListBox;
    lbStatus: TListBox;
    Label4: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    labAuthor: TLabel;
    Label2: TLabel;
    labDescription: TLabel;
    Packages1: TMenuItem;
    N1: TMenuItem;
    LoadPlugin1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Unloadall1: TMenuItem;
    procedure upfPluginManager1NewCommand(Sender, APlugin: TObject;
      ACommand: IupfCommand);
    procedure FormShow(Sender: TObject);
    procedure upfPluginManager1PluginRegistered(Sender, APlugin: TObject);
    procedure clbPluginsClick(Sender: TObject);
    procedure upfPluginManager1BeforePackageLoaded(Sender: TObject;
      AFilename: String; var AllowLoad: Boolean);
    procedure upfPluginManager1AfterPackageLoaded(Sender: TObject;
      AFilename: String);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Packages1Click(Sender: TObject);
    procedure LoadPlugin1Click(Sender: TObject);
    procedure upfPluginManager1PackageUnloaded(Sender: TObject;
      AFilename: String);
    procedure Unloadall1Click(Sender: TObject);
  private
    { Private declarations }
    procedure PackageClick(Sender: TObject); 
  public
    NumButtons: Integer;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.upfPluginManager1NewCommand(Sender, APlugin: TObject;
  ACommand: IupfCommand);
var
  Item : TMenuItem;
  Button : TSpeedButton;
begin
  lbStatus.Items.Add('Adding command: ' + ACommand.Caption);
  Item := NewItem(ACommand.Caption, scNone, False, True, ACommand.OnExecute , 0, '');
  MainMenu1.Items[1].Add(Item);
  ACommand.Objects.Add(Pointer(Item));
  Button := TSpeedButton.Create(Panel1);
  with Button do
  begin
    Top := 4;
    Left := 4 + (NumButtons * Width);
    Parent := Panel1;
    Hint := ACommand.Hint;
    if ACommand.Bitmap <> nil then
      Glyph.Handle := ACommand.Bitmap.Handle;
    try
      NumGlyphs := Glyph.Width div Glyph.Height;
    except
    end;
    OnClick := ACommand.OnExecute;
    ACommand.Objects.Add(pointer(Button))
  end;    // with
  Inc(NumButtons);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   upfPluginManager1.PluginFolder := ExtractFilePath(Application.ExeName);

   { Enable this if you want to auto load all plugins in the folder }
   
   //upfPluginManager1.LoadPlugins;
end;

procedure TForm1.upfPluginManager1PluginRegistered(Sender, APlugin: TObject);
var
  PluginInfo : IupfPlugin;
begin
  if Supports(APlugin, IupfPlugin, PluginInfo) then
    clbPlugins.Items.Add(PluginInfo.PluginName);
end;

procedure TForm1.clbPluginsClick(Sender: TObject);
var
   PluginInfo : IupfPlugin;
begin
   if clbPlugins.ItemIndex = -1 then Exit;

   if Supports(upfPluginManager1.Plugins[clbPlugins.ItemIndex], IupfPlugin, PluginInfo) then
   begin
      labAuthor.Caption := PluginInfo.Author;
      labDescription.Caption := PluginInfo.Description;
   end;
end;

procedure TForm1.upfPluginManager1BeforePackageLoaded(Sender: TObject;
  AFilename: String; var AllowLoad: Boolean);
begin
   lbStatus.Items.Add('Loading Package: ' + ExtractFileName(AFileName));
end;

procedure TForm1.upfPluginManager1AfterPackageLoaded(Sender: TObject;
  AFilename: String);
var
   Item : TMenuItem;
begin
   lbStatus.Items.Add('Finished Loading Package: ' + ExtractFileName(AFileName));

   Item := NewItem(AFilename, scNone, False, True, PackageClick , 0, '');
   Item.Tag := upfPluginManager1.Packages.Count - 1;
   MainMenu1.Items[1].Items[0].Add(Item);

   clbPlugins.Items.Assign(upfPluginManager1.Packages);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
   ShowMessage('Sample TMS Plugin Framework project'#13#10' Copyright  2003-2004, TMS software');
end;

procedure TForm1.PackageClick(Sender: TObject);
begin
  upfPluginManager1.UnloadPlugin((Sender as TMenuItem).Tag);
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Packages1Click(Sender: TObject);
begin
   upfPluginManager1.UnloadPlugin(clbPlugins.ItemIndex);
   showmessage(inttostr(upfPluginManager1.PluginCount));
end;

procedure TForm1.LoadPlugin1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    upfPluginManager1.LoadPlugin(OpenDialog1.FileName);
    showmessage(inttostr(upfPluginManager1.PluginCount));
  end;
end;

procedure TForm1.upfPluginManager1PackageUnloaded(Sender: TObject;
  AFilename: String);
begin
  clbPlugins.Items.Assign(upfPluginManager1.Packages);
end;

procedure TForm1.Unloadall1Click(Sender: TObject);
begin
  upfPluginManager1.UnloadPlugins;
end;

end.
