unit HostAppU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, upfIntf, upfManager, sdiIntf;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Module1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    StatusBar1: TStatusBar;
    upfPluginManager1: TupfPluginManager;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    CurModule : TFrame;
  end;

  TSDIAppServices = class(TupfStandardApplicationServices, ISDIServices)
  private
     SDIModules: TStrings;
  public
     procedure MenuItemClick(Sender: TObject); 
     constructor Create(AOwner : TComponent); override;
     destructor Destroy; override;
     procedure RegisterModule(ADescription : string; APlugin : TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.About1Click(Sender: TObject);
begin
   ShowMessage('SDI Demo'#13#10'Copyright  2003 - 2004, TMS software');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   upfPluginManager1.PluginFolder := ExtractFilePath(Application.EXEName);
   upfPluginManager1.LoadPlugins;
end;

{ TSDIAppServices }

constructor TSDIAppServices.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   SDIModules := TStringList.Create;
end;

destructor TSDIAppServices.Destroy;
begin
   SDIModules.Free;
   inherited Destroy;
end;

procedure TSDIAppServices.MenuItemClick(Sender : TObject);
var
   SDIPlugin : ISDIPlugin;
begin
   // Free the existing module if there is one
   FreeAndNil(Form1.CurModule);

   // Access the SDI Module at the index stored in the TAG property.
   // Call the CreateModule method of the plugin.
   if Supports(SDIModules.Objects[(Sender as TComponent).Tag], ISDIPlugin, SDIPlugin) then
      Form1.CurModule := SDIPlugin.CreateModule(Form1);
end;

procedure TSDIAppServices.RegisterModule(ADescription : string; APlugin : TObject);
var
   SDIPlugin : ISDIPlugin;
   Item      : TMenuItem;
begin
   // If this plugin is indeed an SDI Plugin, add a menu
   // item and register the module.
   if Supports(APlugin, ISDIPlugin, SDIPlugin) then
   begin
      SDIModules.AddObject(ADescription, APlugin);
      Item := NewItem(ADescription, scNone, False, True, MenuItemClick , 0, '');
      Item.Tag := SDIModules.Count - 1;
      Form1.MainMenu1.Items[1].Add(Item);
   end;
end;

initialization
   RegisterClass(TSDIAppServices);

end.
